                                                                          {{  
  Humanoido's Communication Program
  Using Stamps and Props  
  Propeller to BASIC Stamp 2 
  Saturday December 4th, 2010 Version 1.5

 ===============================================================
 Humanoido's Communication Program  - Transmitter
 ===============================================================                                  
 Prop to BS2 - Brain Stem (1 BS2, 1 Propeller)
 Send numbers 0 to 9 each every second to the Stamp and loop 
 ===============================================================
 Propeller to Stamp Transmitter v1.5                                                   
 prop-bs2-level5.spin
 Updated Thursday March 10, 2011
 =============================================================== 
 Giant Brain Project
 Transmits data on a one wire bus
 Propeller to Stamp BUS Communications
 Testing the Brain Stem
 ===============================================================
 
 The Brain Stem consists of a Basic Stamp 2 on a BOE connected
 to a Propeller chip on a PPPB. The connection is made as shown
 below. The Brain Stem is located under the Brain Base. The
 Brain Stem handles the mobility functions of the Giant Brain
 and is the nerve center.
 

  STAMP  ------^^^^^^^--------  PROPELLER
  P0           2.2k ohm         P0
              RESISTOR

  Send numbers 0 to 9 each every second to the Stamp and loop
  Delay Table
  Assuming that a 80 MHz core clock is being used, 800 cycles is about 10us.
  in_pasm(1 + cnt)             Wait for 12.5 ns   80 Mhz 
  in_pasm(8 + cnt)             Wait for 100 ns    10 Mhz  
  in_pasm(80 + cnt)            Wait for 1us       1 Mhz      
  waitcnt(800 + cnt)           Wait for 10us      100 Khz
  waitcnt(8_000 + cnt)         Wait for 100 us    10 Khz  
  waitcnt(80_000 + cnt)        Wait for 1ms       1 Khz
  waitcnt(800_000 + cnt)       Wait for 10 ms     100 Hz
  waitcnt(8_000_000 + cnt)     Wait for 100 ms    10 Hz human reaction speed
  waitcnt(80_000_000 + cnt)    Wait for 1000 ms   1 Hz
  waitcnt(clkfreq + cnt)       Delay one second                    }}
  

CON                                                     ' Define Constants
 _clkmode  = xtal1 + pll16x                             ' Set clock to 80MHz 
 _xinfreq  = 5_000_000                                  ' 5MHz crystal
  tx       = 0                                          ' Set transmit  pin to 0
  baudRate = 9600                                       ' BAUD @ 9600 
  polarity = 0                                          ' No polarity
  bits     = 8                                          ' Eight stop bits

VAR                                                     ' Define variables
  BYTE   num                                            ' number to send

OBJ                                                     ' Objects from OBEX
  bs :  "BS2_Functions"                                 ' Basic Stamp 2 library

PUB start                                               ' Public Object
  BS.start(31, 30)                                      ' Start BS2_Functions
  num := 0                                              ' Init n
  repeat                                                ' Set loop
    BS.serout_dec(tx, num, baudRate, polarity, bits)    ' Send number 1 to BS
    waitcnt(clkfreq + cnt)                              ' Delay one second 
    num++                                               ' Incr number by one                                             
    if num == 10                                        ' Reset to one digit
      num:=0                                            ' Begin again with 0